Package org.apache.catalina.manager

## Class HTMLManagerServlet

- java.lang.Object
- - javax.servlet.GenericServlet
  - - javax.servlet.http.HttpServlet
    - - org.apache.catalina.manager.ManagerServlet
      - - org.apache.catalina.manager.HTMLManagerServlet

All Implemented Interfaces:
  `java.io.Serializable`, `Servlet`, `ServletConfig`, `ContainerServlet`

    public final class HTMLManagerServlet
    extends ManagerServlet

Servlet that enables remote management of the web applications deployed within the same virtual host as this web application is. Normally, this functionality will be protected by a security constraint in the web application deployment descriptor. However, this requirement can be relaxed during testing.

The difference between the `ManagerServlet` and this Servlet is that this Servlet prints out an HTML interface which makes it easier to administrate.

However if you use a software that parses the output of `ManagerServlet` you won't be able to upgrade to this Servlet since the output are not in the same format ar from `ManagerServlet`

Author:
  Bip Thelin, Malcolm Edgar, Glenn L. Nielsen
See Also:
  `ManagerServlet`, Serialized Form

### Field Summary

### Fields inherited from class org.apache.catalina.manager.ManagerServlet

`configBase, context, debug, global, host, mBeanServer, oname, sm, versioned, wrapper`

### Constructor Summary

Constructors
`HTMLManagerServlet()`

### Method Summary

All Methods Instance Methods Concrete Methods
`protected java.lang.String` `deployInternal​(java.lang.String config, ContextName cn, java.lang.String war, StringManager smClient)` Deploy an application for the specified path from the specified web application archive.
`protected void` `displaySessionDetailPage​(HttpServletRequest req, HttpServletResponse resp, ContextName cn, java.lang.String sessionId, StringManager smClient)` Display session details.
`protected void` `displaySessionsListPage​(ContextName cn, HttpServletRequest req, HttpServletResponse resp, StringManager smClient)` List session.
`void` `doGet​(HttpServletRequest request, HttpServletResponse response)` Process a GET request for the specified resource.
`void` `doPost​(HttpServletRequest request, HttpServletResponse response)` Process a POST request for the specified resource.
`protected void` `doSessions​(ContextName cn, HttpServletRequest req, HttpServletResponse resp, StringManager smClient)` Handle session operations.
`protected java.lang.String` `expireSessions​(ContextName cn, HttpServletRequest req, StringManager smClient)` Extract the expiration request parameter
`protected java.lang.String` `findleaks​(StringManager smClient)` Find potential memory leaks caused by web application reload.
`protected java.util.Comparator<Session>` `getComparator​(java.lang.String sortBy)`
`java.lang.String` `getServletInfo()` Returns information about the servlet, such as author, version, and copyright.
`protected Session` `getSessionForNameAndId​(ContextName cn, java.lang.String id, StringManager smClient)`
`protected java.util.List<Session>` `getSessionsForName​(ContextName cn, StringManager smClient)`
`void` `init()` Initialize this servlet.
`protected int` `invalidateSessions​(ContextName cn, java.lang.String[] sessionIds, StringManager smClient)` Invalidate specified sessions.
`protected void` `list​(HttpServletRequest request, HttpServletResponse response, java.lang.String message, StringManager smClient)` Render an HTML list of the currently active Contexts in our virtual host, and memory and server status information.
`protected java.lang.String` `reload​(ContextName cn, StringManager smClient)` Reload the web application at the specified context path.
`protected boolean` `removeSessionAttribute​(ContextName cn, java.lang.String sessionId, java.lang.String attributeName, StringManager smClient)` Removes an attribute from an HttpSession
`protected java.lang.String` `sessions​(ContextName cn, int idle, StringManager smClient)` Display session information and invoke list.
`protected void` `sslConnectorCerts​(HttpServletRequest request, HttpServletResponse response, StringManager smClient)`
`protected void` `sslConnectorCiphers​(HttpServletRequest request, HttpServletResponse response, StringManager smClient)`
`protected void` `sslConnectorTrustedCerts​(HttpServletRequest request, HttpServletResponse response, StringManager smClient)`
`protected java.lang.String` `sslReload​(java.lang.String tlsHostName, StringManager smClient)`
`protected java.lang.String` `start​(ContextName cn, StringManager smClient)` Start the web application at the specified context path.
`protected java.lang.String` `stop​(ContextName cn, StringManager smClient)` Stop the web application at the specified context path.
`protected java.lang.String` `undeploy​(ContextName cn, StringManager smClient)` Undeploy the web application at the specified context path.
`protected java.lang.String` `upload​(HttpServletRequest request, StringManager smClient)`

### Methods inherited from class org.apache.catalina.manager.ManagerServlet

`addServiced, check, deploy, deploy, deploy, destroy, doPut, expireSessions, findleaks, getConnectorCerts, getConnectorCiphers, getConnectorTrustedCerts, getWrapper, isDeployed, isServiced, list, printResources, printResources, reload, removeServiced, resources, save, serverinfo, sessions, setWrapper, sslConnectorCiphers, sslReload, start, stop, threadDump, tryAddServiced, undeploy, uploadWar, validateContextName, vmInfo`

### Methods inherited from class javax.servlet.http.HttpServlet

`doDelete, doHead, doOptions, doTrace, getLastModified, service, service`

### Methods inherited from class javax.servlet.GenericServlet

`getInitParameter, getInitParameterNames, getServletConfig, getServletContext, getServletName, init, log, log`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### HTMLManagerServlet

    public HTMLManagerServlet()

### Method Detail

#### doGet

    public void doGet​(HttpServletRequest request,
                      HttpServletResponse response)
               throws java.io.IOException,
                      ServletException

Process a GET request for the specified resource.

Overrides:
  `doGet` in class `ManagerServlet`
Parameters:
  `request` - The servlet request we are processing
  `response` - The servlet response we are creating
Throws:
  `java.io.IOException` - if an input/output error occurs
  `ServletException` - if a servlet-specified error occurs
See Also:
  `ServletResponse.setContentType(java.lang.String)`

#### doPost

    public void doPost​(HttpServletRequest request,
                       HttpServletResponse response)
                throws java.io.IOException,
                       ServletException

Process a POST request for the specified resource.

Overrides:
  `doPost` in class `HttpServlet`
Parameters:
  `request` - The servlet request we are processing
  `response` - The servlet response we are creating
Throws:
  `java.io.IOException` - if an input/output error occurs
  `ServletException` - if a servlet-specified error occurs
See Also:
  `ServletOutputStream`, `ServletResponse.setContentType(java.lang.String)`

#### upload

    protected java.lang.String upload​(HttpServletRequest request,
                                      StringManager smClient)

#### deployInternal

    protected java.lang.String deployInternal​(java.lang.String config,
                                              ContextName cn,
                                              java.lang.String war,
                                              StringManager smClient)

Deploy an application for the specified path from the specified web application archive.

Parameters:
  `config` - URL of the context configuration file to be deployed
  `cn` - Name of the application to be deployed
  `war` - URL of the web application archive to be deployed
  `smClient` - internationalized strings
Returns:
  message String

#### list

    protected void list​(HttpServletRequest request,
                        HttpServletResponse response,
                        java.lang.String message,
                        StringManager smClient)
                 throws java.io.IOException

Render an HTML list of the currently active Contexts in our virtual host, and memory and server status information.

Parameters:
  `request` - The request
  `response` - The response
  `message` - a message to display
  `smClient` - internationalized strings
Throws:
  `java.io.IOException` - an IO error occurred

#### reload

    protected java.lang.String reload​(ContextName cn,
                                      StringManager smClient)

Reload the web application at the specified context path.

Parameters:
  `cn` - Name of the application to be restarted
  `smClient` - StringManager for the client's locale
Returns:
  message String
See Also:
  `ManagerServlet.reload(PrintWriter, ContextName, StringManager)`

#### undeploy

    protected java.lang.String undeploy​(ContextName cn,
                                        StringManager smClient)

Undeploy the web application at the specified context path.

Parameters:
  `cn` - Name of the application to be undeployed
  `smClient` - StringManager for the client's locale
Returns:
  message String
See Also:
  `ManagerServlet.undeploy(PrintWriter, ContextName, StringManager)`

#### sessions

    protected java.lang.String sessions​(ContextName cn,
                                        int idle,
                                        StringManager smClient)

Display session information and invoke list.

Parameters:
  `cn` - Name of the application to list session information
  `idle` - Expire all sessions with idle time ≥ idle for this context
  `smClient` - StringManager for the client's locale
Returns:
  message String
See Also:
  `ManagerServlet.sessions(PrintWriter, ContextName, int, StringManager)`

#### start

    protected java.lang.String start​(ContextName cn,
                                     StringManager smClient)

Start the web application at the specified context path.

Parameters:
  `cn` - Name of the application to be started
  `smClient` - StringManager for the client's locale
Returns:
  message String
See Also:
  `ManagerServlet.start(PrintWriter, ContextName, StringManager)`

#### stop

    protected java.lang.String stop​(ContextName cn,
                                    StringManager smClient)

Stop the web application at the specified context path.

Parameters:
  `cn` - Name of the application to be stopped
  `smClient` - StringManager for the client's locale
Returns:
  message String
See Also:
  `ManagerServlet.stop(PrintWriter, ContextName, StringManager)`

#### findleaks

    protected java.lang.String findleaks​(StringManager smClient)

Find potential memory leaks caused by web application reload.

Parameters:
  `smClient` - StringManager for the client's locale
Returns:
  message String
See Also:
  `ManagerServlet.findleaks(boolean, PrintWriter, StringManager)`

#### sslReload

    protected java.lang.String sslReload​(java.lang.String tlsHostName,
                                         StringManager smClient)

#### sslConnectorCiphers

    protected void sslConnectorCiphers​(HttpServletRequest request,
                                       HttpServletResponse response,
                                       StringManager smClient)
                                throws ServletException,
                                       java.io.IOException

Throws:
  `ServletException`
  `java.io.IOException`

#### sslConnectorCerts

    protected void sslConnectorCerts​(HttpServletRequest request,
                                     HttpServletResponse response,
                                     StringManager smClient)
                              throws ServletException,
                                     java.io.IOException

Throws:
  `ServletException`
  `java.io.IOException`

#### sslConnectorTrustedCerts

    protected void sslConnectorTrustedCerts​(HttpServletRequest request,
                                            HttpServletResponse response,
                                            StringManager smClient)
                                     throws ServletException,
                                            java.io.IOException

Throws:
  `ServletException`
  `java.io.IOException`

#### getServletInfo

    public java.lang.String getServletInfo()

Description copied from class: `javax.servlet.GenericServlet`
Returns information about the servlet, such as author, version, and copyright. By default, this method returns an empty string. Override this method to have it return a meaningful value. See `Servlet.getServletInfo()`.

Specified by:
  `getServletInfo` in interface `Servlet`
Overrides:
  `getServletInfo` in class `GenericServlet`
Returns:
  String information about this servlet, by default an empty string
See Also:
  `Servlet.getServletInfo()`

#### init

    public void init()
              throws ServletException

Description copied from class: `ManagerServlet`
Initialize this servlet.

Overrides:
  `init` in class `ManagerServlet`
Throws:
  `ServletException` - if an exception occurs that interrupts the servlet's normal operation
See Also:
  `GenericServlet.init()`

#### expireSessions

    protected java.lang.String expireSessions​(ContextName cn,
                                              HttpServletRequest req,
                                              StringManager smClient)

Extract the expiration request parameter

Parameters:
  `cn` - Name of the application from which to expire sessions
  `req` - The Servlet request
  `smClient` - StringManager for the client's locale
Returns:
  message string

#### doSessions

    protected void doSessions​(ContextName cn,
                              HttpServletRequest req,
                              HttpServletResponse resp,
                              StringManager smClient)
                       throws ServletException,
                              java.io.IOException

Handle session operations.

Parameters:
  `cn` - Name of the application for the sessions operation
  `req` - The Servlet request
  `resp` - The Servlet response
  `smClient` - StringManager for the client's locale
Throws:
  `ServletException` - Propagated Servlet error
  `java.io.IOException` - An IO error occurred

#### getSessionsForName

    protected java.util.List<Session> getSessionsForName​(ContextName cn,
                                                         StringManager smClient)

#### getSessionForNameAndId

    protected Session getSessionForNameAndId​(ContextName cn,
                                             java.lang.String id,
                                             StringManager smClient)

#### displaySessionsListPage

    protected void displaySessionsListPage​(ContextName cn,
                                           HttpServletRequest req,
                                           HttpServletResponse resp,
                                           StringManager smClient)
                                    throws ServletException,
                                           java.io.IOException

List session.

Parameters:
  `cn` - Name of the application for which the sessions will be listed
  `req` - The Servlet request
  `resp` - The Servlet response
  `smClient` - StringManager for the client's locale
Throws:
  `ServletException` - Propagated Servlet error
  `java.io.IOException` - An IO error occurred

#### displaySessionDetailPage

    protected void displaySessionDetailPage​(HttpServletRequest req,
                                            HttpServletResponse resp,
                                            ContextName cn,
                                            java.lang.String sessionId,
                                            StringManager smClient)
                                     throws ServletException,
                                            java.io.IOException

Display session details.

Parameters:
  `req` - The Servlet request
  `resp` - The Servlet response
  `cn` - Name of the application for which the sessions will be listed
  `sessionId` - the session id
  `smClient` - StringManager for the client's locale
Throws:
  `ServletException` - Propagated Servlet error
  `java.io.IOException` - An IO error occurred

#### invalidateSessions

    protected int invalidateSessions​(ContextName cn,
                                     java.lang.String[] sessionIds,
                                     StringManager smClient)

Invalidate specified sessions.

Parameters:
  `cn` - Name of the application for which sessions are to be invalidated
  `sessionIds` - the session ids of the sessions
  `smClient` - StringManager for the client's locale
Returns:
  number of invalidated sessions

#### removeSessionAttribute

    protected boolean removeSessionAttribute​(ContextName cn,
                                             java.lang.String sessionId,
                                             java.lang.String attributeName,
                                             StringManager smClient)

Removes an attribute from an HttpSession

Parameters:
  `cn` - Name of the application hosting the session from which the attribute is to be removed
  `sessionId` - the session id
  `attributeName` - the attribute name
  `smClient` - StringManager for the client's locale
Returns:
  true if there was an attribute removed, false otherwise

#### getComparator

    protected java.util.Comparator<Session> getComparator​(java.lang.String sortBy)